/*
 * Project:		Audio Engine SaintSonic
 * Version:		07_03_21
 * Copyright:	(c) 2006-2007 Saint'en Tear / VVani
 *
 * Before using this, take a look doc/readme.txt.
 */

#include "stdint.h"

#ifndef SAINTSONIC_H
#define SAINTSONIC_H

#define ssdecl _cdecl

typedef void*	SaintSonic_EnginePtr;
typedef int32_t	SaintSonic_SoundId;

#define SSW_DefaultSamplingRate		44100	// Hz
#define SSW_DefaultChannels			2		// Stereo
#define SSW_DefaultUnitBits			16		// 2 bytes per one wave value
#define SSW_DefaultBufferSize_ms	50		// milliseconds

#define SSW_LOOP_MAX 2147483647
#define SSW_LOOP_MIN 0

#ifdef __cplusplus
extern "C" {
#endif
	SaintSonic_EnginePtr ssdecl SSW_Initialize( uint32_t, uint8_t, uint8_t, int32_t );
	SaintSonic_SoundId ssdecl SSW_PlaySound_cs( SaintSonic_EnginePtr pEngine, char* Filename );
	int32_t ssdecl SSW_SeekSound( SaintSonic_EnginePtr, SaintSonic_SoundId, uint32_t, int8_t );
	int32_t ssdecl SSW_AddLoopInfo( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, int32_t From_ms, int32_t To_ms, int32_t Count );
	int32_t ssdecl SSW_PauseSound( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID );
	int32_t ssdecl SSW_ResumeSound( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID );
	int32_t ssdecl SSW_SetVolume( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, float newVolume );
	int32_t ssdecl SSW_SetFade( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, int32_t Time_ms, float First, float Final );
	void ssdecl SSW_Finish( SaintSonic_EnginePtr pEngine);
	#define SSW_PlaySound SSW_PlaySound_cs
#ifdef __cplusplus
}
#endif

#endif