﻿/*
 * Project:		Audio Engine SaintSonic
 * Version:		07_03_21
 * Copyright:	(c) 2006-2007 Saint'en Tear / VVani
 *
 * Before using this, take a look doc/readme.txt.
 */

module saintsonic.saintsonic;

private import std.stdint;

alias void*		SaintSonic_EnginePtr;
alias int32_t	SaintSonic_SoundId;

const uint32_t  DefaultSamplingRate	 = 44100 ;	// Hz
const uint8_t   DefaultChannels		 = 2;		// Stereo
const uint8_t   DefaultUnitBits		 = 16;		// 2 bytes per one wave value
const int32_t   DefaultBufferSize_ms = 50;		// milliseconds

extern(C)
{
	SaintSonic_EnginePtr SSW_Initialize( int32_t SamplingRate = DefaultSamplingRate, uint8_t Channels = DefaultChannels, uint8_t UnitBits = DefaultUnitBits, int32_t BufferSize_ms = DefaultBufferSize_ms );
	SaintSonic_SoundId SSW_PlaySound( SaintSonic_EnginePtr pEngine, char[] Filename );
	int16_t SSW_SeekSound( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, int32_t Position_ms, bit isAbsolute = false );
	int16_t SSW_AddLoopInfo( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, int32_t From_ms = int32_t.max, int32_t To_ms = 0, int32_t Count = int32_t.max);
	int16_t SSW_PauseSound( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID );
	int16_t SSW_ResumeSound( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID );
	int16_t SSW_SetVolume( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, float newVolume );
	int16_t SSW_SetFade( SaintSonic_EnginePtr pEngine, SaintSonic_SoundId SoundID, int32_t Time_ms, float First, float Final );
	void SSW_Finish( SaintSonic_EnginePtr pEngine);
}
